package com.app.dao.impl;

import java.sql.SQLException;
import java.util.List;

import net.sf.hibernate.Criteria;
import net.sf.hibernate.HibernateException;
import net.sf.hibernate.Session;
import net.sf.hibernate.expression.Expression;

import org.springframework.dao.DataAccessException;
import org.springframework.orm.hibernate.HibernateCallback;
import org.springframework.orm.hibernate.HibernateTemplate;

import com.app.dao.UserDAO;
import com.app.model.User;


/**
 * This class interacts with Spring and Hibernate to retrieve User objects.
 * 
 * @author aymen REKIK
 */
public class UserDAOImpl  implements UserDAO {

	private HibernateTemplate hibernateTemplate;

    public void setHibernateTemplate(HibernateTemplate hibernateTemplate){
        this.hibernateTemplate = hibernateTemplate;
    }

    public HibernateTemplate getHibernateTemplate(){
        return hibernateTemplate;
    }
    
	@SuppressWarnings("unchecked")
	public List  getUser(final String  login, final String pass) throws DataAccessException {
        //return getHibernateTemplate().find("from User where login like '"+login+"' and password like '"+pass+"'");
        
        
        HibernateCallback callback = new HibernateCallback() {
	            public Object doInHibernate(Session session)  throws HibernateException,SQLException {
	                Criteria criteria = session.createCriteria(User.class);
	                criteria.add(Expression.eq("login", login));
	                criteria.add(Expression.eq("password", pass));
	                return criteria.list();
	            }
	        };
	        return (List)getHibernateTemplate().execute(callback);
    }

}
